/*	Po co zmieniem tutaj nazwe?
	eby nie byo konfliktw z
	nagwkiem ekspert'a :)
*/
#ifndef	_TEXTURE_SPC_H
#define	_TEXTURE_SPC_H

#include <gl/gl.h>
#include <gl/glu.h>
#include <stdio.h>	// Nagwek od operacji na plikach
#include <string>	// Nagwek od klasy acucha znakw
#include <vector>
#include "Log.h"

// Klasa do zarzdzania jedn tekstur
class ioTexture
{
private:
	// tablica trzymajca adresy pamici tekstury ( jest 5 poziomw jakoci )
	unsigned int texture[3];
	std::string file;

	// zmienna dla oritacji czy tektrura jest gotowa
	bool loaded;
public:
	// Konstruktor i Destruktor
	ioTexture();
	ioTexture( std::string filename );
	virtual ~ioTexture();

	// Funkcja adujca obraz z pliku TGA
	virtual bool LoadTGA( std::string filename );

	// Funkcja aktywujca tekstur
	virtual void Activate( unsigned int tex = 2 );

	// Funkcja zwalniajca pami
	virtual void Free();

	// Metoda zwraca nazwe aktualnie zaadowanego pliku
	virtual std::string GetFile();
};


class ioTexManager
{
private:
	std::vector<ioTexture*> List;
public:
	ioTexManager();
	~ioTexManager();
	ioTexture* Get( std::string filename );
	void AddTexture( ioTexture* Tex );
	void DeleteTexture( unsigned int index );
	ioTexture* GetTexture( unsigned int index );
	void Clear();
};

extern ioTexManager TManager;

#endif